/* ****************************************************************************
* :  
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//       setlocale()
#include <locale.h>

//       malloc()  free()
#include <stdlib.h>

#define  NAME_LEN  31

/*
         
    ,       UTF-8.
     :
  
  gcc -DWIDE -o prg13 prg13.c

         prg18.c.
*/
#ifdef WIDE
  #define  YES L''
  #define  NO  L''
  #define  FORMAT  "%lc"
#else
  #define  YES ''
  #define  NO  ''
  #define  FORMAT  "%c"
#endif

//    ,     
struct person 
{
  char first_name[ NAME_LEN ];  // 
  char last_name[ NAME_LEN ];   // 
  int height;                   //  ( )
  float weight;                 //  ( )
};



int main( void )
{
  int i, j;       //  

#ifdef WIDE
  wchar_t answer; //     
#else
  char answer;    //     
#endif

  int count;      //    

  //     ,     C,
  //      
  
  //      
  struct person students[ 3 ] = { { "", "", 180, 78.56 },
                                  { "", "", 160, 64.88 }, 
                                  { "", "", 175, 72.40 }
                                };

  //      person
  struct person *p_manager;

  //        person
  struct person *managers;

  //       , 
  //    
  if ( !setlocale( LC_CTYPE, "" ) )
  {
    fprintf( stderr, "Can't set locale LC_CTYPE\n" );
    exit( 1 );
  }

  //         3 
  managers = ( struct person * )malloc( sizeof ( struct person ) * 3 );

  //     malloc()
  if ( managers == NULL )
  {
    puts( "      " );
    exit( 1 );     // ""  
  }

  //    
  printf( "    (3 )\n");

  for ( i = 0; i < 3; i++ )  
  {
    //      
    printf( "\n     ,   \n" );
    printf( "(, , , ):\n" );
    scanf( "%s %s %d %f", managers[ i ].first_name, managers[ i ].last_name, 
                          &managers[ i ].height, &managers[ i ].weight );

    count = i;      //    

    //     ,    
    //  scanf()        
    //      
    while ( getchar() != '\n' )
      continue;

    //      , ...
    if ( i < 2 )
    {
      // ...    ,     

      answer = '\0';
      while ( answer != YES && answer != NO )
      {
        printf( "\n   (/) ?: " );
        scanf( FORMAT, &answer );

        //     ,    
        //  scanf()        
        //      
        while ( getchar() != '\n' )
          continue;
      }

      if ( answer == NO )     //   - ''
        break;                //    
    }
  }


  //  

  // ,       ,  
  //   ,      
  //   count.
  //       ,   
  //     .   p_manager  
  //    .    managers
  //  , . .         
  // ,    ,    , 
  //         free()  
  //     .
  // ,       1    
  //    ,    .  , 
  //         .  
  //         
  //    --   "."   "->".
  //           managers 
  // (     ).

  //  ,       
  //  "<=",   "<"
  for ( i = 0, p_manager = managers; i <= count; i++, p_manager++ )  
  {
    //      
    printf( " %d: %s %s %d %.2f\n", i + 1,
                                          p_manager->first_name,
                                          p_manager->last_name, 
                                          p_manager->height, 
                                          p_manager->weight );
  }

  //  
  free( managers );

  return 0;
}
