/* ****************************************************************************
* ணࠬ: ᯨ᮪ 㤥⮢
* :    ࠡ  ᯨ᪠ 㤥᪨ 㯯
* :     . . 㭮
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//  䠩 㦥  㭪樨 strlen()
#include <string.h>

//  প ப ᨬ
#include <wchar.h>

#include "students.h"


// 祢 ᫮ static 砥,   㭪 㯭 ⮫쪮 
// 㣨 㭪権, ᮤঠ  ⮬  ணࠬ 㫥. ⮬ 
// ᬮ ᯮ짮   㭪権  ࠧ ணࠬ .
//    㤮,  ⠪ 㭪樨 室  ࠧ ,
//  믮  樨, ਬ,  .
static int add( void );
static int find( void );
static int list( void );
static int delete( void );
static int update( void );


//  ६ ⨯ STUDENT
//   ⮩   樠樨  祭 0, . . 
//  ⮫쪮  ᨬ '\0' (  㢨   ⫠稪
//  ᫨  䠩 students.db  ⥪⮢ ।,  "㬥"
// 뢠 ASCII- ⮣ ᨬ,  ஬ ⮨ )

// ॣ ᨬ  祭, ⮬  ᯮ짮 ⠪ 
static STUDENT student;


/* ****************************************************************************
* ନ஢   ࠡ  ᯨ᪠ 㤥᪨ 㯯
* ****************************************************************************/
void lists( void )
{
  char answer;     // ⢥ 짮⥫  롮 㭪 

  printf( "\n᪨ 㤥᪨ 㯯\n" );

  // ᢮ ६ answer ⠪ 祭, ஥   
  //  横
  answer = '1';

  while ( answer == '1' || answer == '2' || answer == '3' || 
          answer == '4' || answer == '5' )
  {
    printf( "\n" );              //  ப
    printf( "1. ᪨ 㤥᪨ 㯯\n" );
    printf( "2.   㤥\n" );
    printf( "3. ४஢  㤥\n" );
    printf( "4.   㤥\n" );
    printf( "5.   㤥\n" );
    printf( "6. 室    ணࠬ\n\n" );

    printf( "롥 ⢨: " );
    scanf( "%c", &answer );      // ⢥ 稬   ᨬ,   ᫠
    printf( "\n" );              //  ப

    // ⨬  
    while ( getchar() != '\n' )
      continue;

    if ( answer == '1' )
    {
      list();
    }
    else if ( answer == '2' )
    {
      add();
    }
    else if ( answer == '3' )
    {
      update();
    }
    else if ( answer == '4' )
    {
      delete();
    }
    else if ( answer == '5' )
    {
      find();
    }
    else if ( answer == '6' )
    {
      return;
    }
    else    // ࠭ - 㣮 ᨬ
    {
      printf( " ࠢ  㭪 \n" );

      // ᢮ ६ answer ⠪ 祭, ஥   
      //   横
      answer = '1';
    }
  }
  return;
}


/* ****************************************************************************
*   㤥
* ****************************************************************************/
static int add( void )
{
  //  稪 ⢠ ᥩ  㤥,   ६ ⥪饣
  // ᥠ ࠡ  ணࠬ
  // ६  祢 ᫮ static ࠭ ᢮ 祭  
  // 맮 ⮩ 㭪樨,  ன  ।
  static int count_students = 0;
  
#ifdef UTF8
  wchar_t answer;  // ⢥ 짮⥫   
#else
  char answer;     // ⢥ 짮⥫   
#endif

  int written;     // 稪 ᫠  , ᯥ譮 ᠭ  䠩

  // 䠩  ࠭ ᯨ᪮ 㤥⮢
  FILE *out;

  // ஥  䠩 ᯨ᪮ 㤥⮢  ०  ᥩ
  //   䠩 ( 襬 䠩 ७ "db",  砥 database)
  out = fopen( "students.db", "ab" );

  // ᫨ 䠩  (ᮧ)  㤠,  㪠⥫  祭 NULL
  if ( out == NULL )
  {
    fprintf( stderr, "   䠩 students.db\n" );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }

  printf( "  㤥\n\n" );

  // ᢮ ६ answer ⠪ 祭, ஥   
  //  横
  answer = YES;

  while ( answer == YES )
  {
    // 㤥     ⤥쭮 ப
    printf( " 㯯 (  %d ᨬ  ஡): ",
            GROUP_CODE_LEN - 1 );
    gets( student.group_code );

    printf( "\n (  %d ᨬ): ", NAME_LEN - 1 );
    gets( student.last_name );

    printf( "\n (  %d ᨬ): ", NAME_LEN - 1 );
    gets( student.first_name );

    printf( "\n ( ᠭ⨬): " );
    scanf( "%d", &student.height );

    printf( "\n ( ࠬ) " \
            "(  ⤥ ᨬ \".\"): " );
    scanf( "%f", &student.weight );

    // ⨬  
    while ( getchar() != '\n' )
      continue;
 
    //   "ਧ 㤠 " 襬 祭 '\0', . . 
    //      ஬  , ⢥,  㤥
    // 祭  㤠
    student.deleted = '\0';

    // 襬    䠩 students.db
    written = fwrite( &student, sizeof( student ), 1, out );

    if ( written != 1 )
      printf( "訡     䠩 students.db\n" );
    else
      printf( " ⮬ ᥠ ࠡ  ணࠬ   %d ᥩ "
              " 㤥\n", ++count_students );
      
    // ᨬ  짮⥫,    த , 祬, 㤥
    // ⠨  ⮬, ⮡ 짮⥫  த   "",
    //   襭    -  㪢,   ""
    // (⮡ ⪠  த  ᫥,   ᯥ譮)

    // ᢮ ६ answer ⠪ 祭, ஥   
    //  横
    answer = '\0';

    while ( answer != YES && answer != NO )
    {
      printf( "\nத   (/) ?: " );
      scanf( FORMAT, &answer );

      // ⨬  
      while ( getchar() != '\n' )
        continue;

    }
  }  
  
  // ஥ 䠩
  fclose( out );

  return;
}


/* ****************************************************************************
* 㤠   㤥  䠩 students.db
* ****************************************************************************/
static int delete( void )
{
  int  written;    // 稪 ᫠  , ᯥ譮 ᠭ  䠩

  //  㤥᪮ 㯯  䠩
  char grp_code[ GROUP_CODE_LEN ];

  // 䠬 㤥  䠩
  char last_name[ NAME_LEN ];

  char deleted_mark = '*';  // ⪠ 㤠 
  int found = 0;            // ਧ ⮣,    䠩 
 
  // 䠩  ࠭ ᯨ᪮ 㤥⮢
  FILE *students;

  // ஥ 䠩  ० ⥭   
  students = fopen( "students.db", "r+b" );

  // ஢塞 ᯥ譮  䠩
  if ( students == NULL )
  {
    fprintf( stderr, "   䠩 students.db\n" );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }

  printf( "  㤥\n\n" );

  printf( "  㤥᪮ 㯯 \n" \
          "(  %d ᨬ  ஡): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n 䠬 㤥 (  %d ᨬ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //  ப  ࠭

  // ⠥ 䠩   , ⠢饩   㤥
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    // ᫨   祭  㤠
    if ( student.deleted )
      continue;    // 室  砫 横, . . ⠥ ᫥ 

    // ᫨  짮⥫  㯯  䠬 㤥 ᮢ
    //  ⥬,  ᮤঠ  ⠭   䠩
    if ( strcmp( grp_code, student.group_code ) == 0 && 
         strcmp( last_name, student.last_name ) == 0
       )
    {
      found = 1;    //   -- ᢮ 䫠 㫥 祭

      // ६⨬ 㪠⥫ 樨  䠩  砫 ⮩  ()
      // ࠬ SEEK_CUR 砥,  ६饭 㪠⥫ 樨
      // 믮   樨  䠩;  "-" 砥 ६饭
      //  ஭  䠩
      fseek( students, -( sizeof( student ) ), SEEK_CUR );

      // 襬  㤠     䠩 students.db
      written = fwrite( &deleted_mark, 1, 1, students );

      if ( written == 1 )
        printf( " 㤠\n" );
      else
        printf( "訡     䠩 students.db\n" );

      break;      // 室  横, . .    ࠡ⠭
    }
  }

  //   ࠢᨫ쭠 ⠪: if ( found == 0 )
  if ( !found )  //  짮⥫ 祢   䠩  
    printf( "  㯯  䠬 㤥\n" );

  // ஥ 䠩
  fclose( students );

  return 0;        // ᯥ譮 襭 楤
}


/* ****************************************************************************
*    㤥  䠩 students.db
* ****************************************************************************/
static int find( void )
{
  //  㤥᪮ 㯯  䠩
  char grp_code[ GROUP_CODE_LEN ];

  // 䠬 㤥  䠩
  char last_name[ NAME_LEN ];

  int found = 0;            // ਧ ⮣,    䠩 
 
  // 䠩  ࠭ ᯨ᪮ 㤥⮢
  FILE *students;

  // ஥ 䠩  ० ⥭
  students = fopen( "students.db", "rb" );

  // ஢塞 ᯥ譮  䠩
  if ( students == NULL )
  {
    fprintf( stderr, "   䠩 students.db\n" );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }

  printf( "  㤥\n\n" );

  printf( "  㤥᪮ 㯯 \n" \
          "(  %d ᨬ  ஡): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n 䠬 㤥 (  %d ᨬ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //  ப  ࠭

  // ⠥ 䠩   , ⠢饩 ᠭ  㤥
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    // ᫨   祭  㤠
    if ( student.deleted )
      continue;    // 室  砫 横, . . ⠥ ᫥ 

    // ᫨  짮⥫  㯯  䠬 㤥 ᮢ
    //  ⥬,  ᮤঠ  ⠭   䠩
    if ( strcmp( grp_code, student.group_code ) == 0 && 
         strcmp( last_name, student.last_name ) == 0
       )
    {
      found = 1;    //   -- ᢮ 䫠 㫥 祭

      // 뢥    ப
      printf( "%s %s %s %d %.2f\n", student.group_code, student.last_name,
                                    student.first_name, student.height,
                                    student.weight );

      break;        // 室  横, . .    ࠡ⠭
    }
  }

  //   ࠢᨫ쭠 ⠪: if ( found == 0 )
  if ( !found )  //  짮⥫ 祢   䠩  
    printf( "  㯯  䠬 㤥\n" );

  // ஥ 䠩
  fclose( students );

  return 0;        // ᯥ譮 襭 楤
}


/* ****************************************************************************
* 뢮 ᯨ᪠  㤥᪮ 㯯
* ****************************************************************************/
static int list( void )
{
  int written;     // 稪 ᫠  , ᯥ譮 ᠭ  䠩
  int i;           // 稪 ᫠ 뢥 ᥩ

  int found = 0;   // ਧ ⮣,    䠩 

  //  㤥᪮ 㯯  䠩
  char grp_code[ GROUP_CODE_LEN ];

  // 䠩  ࠭ ᯨ᪮ 㤥⮢
  FILE *students;

  // ஥ ⥯ 䠩  ० ⥭  뢥 ᮤন 䠩
  students = fopen( "students.db", "rb" );

  // ஢塞 ᯥ譮  䠩
  if ( students == NULL )
  {
    fprintf( stderr, "   䠩 students.db\n" );
    return 1;      // ᯥ譮 襭 楤
  }

  printf( "᪨ 㤥᪨ 㯯\n\n" );

  printf( "  㤥᪮ 㯯 \n" \
          "(  %d ᨬ  ஡): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n" );   //  ப  ࠭

  printf( "᮪ 㯯 %s\n\n", grp_code );

  i = 1;   // 㤥 㬥஢ 뢮   㤥

  // 㤥  横   䠩 students.db   ன
  // (. .   )
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    // ᫨   祭  㤠
    if ( student.deleted )
      continue;    // 室  砫 横, . . ⠥ ᫥ 

    // ᫨  짮⥫  㯯 ᮢ  ⥬, 
    // ᮤন  ⠭   䠩
    if ( strcmp( grp_code, student.group_code ) == 0 )
    {
      found = 1;    //   -- ᢮ 䫠 㫥 祭

      // 뢥    ப
      // 祭  student.group_code 뢮  㤥 --  ᫠
      printf( "%d. %s %s %d %.2f\n", i,
                                     student.last_name,
                                     student.first_name,
                                     student.height,
                                     student.weight );
      i++;
    }
  }

  //   ࠢᨫ쭠 ⠪: if ( found == 0 )
  if ( !found )  //  짮⥫  㯯  䠩  
    printf( "  㯯\n" );

  // ஥ 䠩
  fclose( students );

  return 0;
}


/* ****************************************************************************
* ४஢    㤥  䠩 students.db
* ****************************************************************************/
static int update( void )
{
  int  written;    // 稪 ᫠  , ᯥ譮 ᠭ  䠩

  char  grp_code[ GROUP_CODE_LEN ];    //  㤥᪮ 㯯
  char  last_name[ NAME_LEN ];         // 䠬
  char  first_name[ NAME_LEN ];        // 
  char  height[ 5 ];                   //  ( ᠭ⨬)
  char  weight[ 7 ];                   //  ( ࠬ)

  int found = 0;            // ਧ ⮣,    䠩 
  int updated = 0;          // ਧ ⮣,    䠩 

  // 䠩  ࠭ ᯨ᪮ 㤥⮢
  FILE *students;

  // ஥ 䠩  ० ⥭   
  students = fopen( "students.db", "r+b" );

  // ஢塞 ᯥ譮  䠩
  if ( students == NULL )
  {
    fprintf( stderr, "   䠩 students.db\n" );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }

  printf( "४஢  㤥\n\n" );

  printf( "  㤥᪮ 㯯 \n" \
          "(  %d ᨬ  ஡): ", GROUP_CODE_LEN - 1 );
  gets( grp_code );

  printf( "\n 䠬 㤥 (  %d ᨬ): ", NAME_LEN - 1 );
  gets( last_name );

  printf( "\n" );   //  ப  ࠭

  // ⠥ 䠩   , ⠢饩 ᠭ  㤥
  while ( fread( &student, sizeof( student ), 1, students ) == 1 )
  {
    // ᫨   祭  㤠
    if ( student.deleted )
      continue;    // 室  砫 横, . . ⠥ ᫥ 

    // ᫨  짮⥫  㯯  䠬 㤥
    //  ᮢ  ⥬,  ᮤঠ  ⠭   䠩
    // (ᨬ "||"  ᪮ "")
    if ( strcmp( grp_code, student.group_code ) != 0 || 
         strcmp( last_name, student.last_name ) != 0 )
      continue;    // 室  砫 横, . . ⠥ ᫥ 

    found = 1;     //   -- ᢮ 䫠 㫥 祭

    // 뢥  ࠭ ⥪騥 祭    ப
    printf( "%s %s %s %d %.2f\n\n", student.group_code, student.last_name,
                                    student.first_name, student.height,
                                    student.weight );

    // ᨬ 짮⥫  
    printf( "  祭 .\n" \
            "᫨ 室 ⠢ ० 祭 , " \
            "   Enter\n\n");

    // 㤥     ⤥쭮 ப
    printf( " 㯯 (  %d ᨬ  ஡): ",
            GROUP_CODE_LEN - 1 );
    gets( grp_code );

    printf( "\n (  %d ᨬ): ", NAME_LEN - 1 );
    gets( last_name );

    printf( "\n (  %d ᨬ): ", NAME_LEN - 1 );
    gets( first_name );

    printf( "\n ( ᠭ⨬): " );
    gets( height );

    printf( "\n ( ࠬ) " \
            "(  ⤥ ᨬ \".\"): " );
    gets( weight );

    printf( "\n" );   //  ப  ࠭

    // ᫨   祭   " 㯯"
    if ( strlen( grp_code ) != 0 )
    {
      // ᪮㥬  祭   
      strcpy( student.group_code, grp_code );
      updated = 1;                       // ਧ --  
    }

    // ᫨   祭   ""
    if ( strlen( last_name ) != 0 )
    {
      // ᪮㥬  祭   
      strcpy( student.last_name, last_name );
      updated = 1;                        // ਧ --  
    }

    // ᫨   祭   ""
    if ( strlen( first_name ) != 0 )
    {
      // ᪮㥬  祭   
      strcpy( student.first_name, first_name );
      updated = 1;                        // ਧ --  
    }

    // ᫨   祭   ""
    if ( strlen( height ) != 0 )
    {
      // ᪮㥬  祭   
      // 㭪 sscanf() ८ࠧ ப  ᫮
      sscanf( height, "%d", &student.height );
      updated = 1;                        // ਧ --  
    }

    // ᫨   祭   ""
    if ( strlen( weight ) != 0 )
    {
      // ᪮㥬  祭   
      sscanf( weight, "%f", &student.weight );
      updated = 1;                        // ਧ --  
    }

    // ᫨ 뫮   祭      
    if ( updated )   //  ᫮   ⠪: if ( updated == 1 )
    {
      // ६⨬ 㪠⥫ 樨  䠩  砫 ⮩  ()
      // ࠬ SEEK_CUR 砥,  ६饭 㪠⥫ 樨
      // 믮   樨  䠩;  "-" 砥 ६饭
      //  ஭  䠩
      fseek( students, -( sizeof( student ) ), SEEK_CUR );

      // 襬    䠩 students.db
      written = fwrite( &student, sizeof( student ), 1, students );

      if ( written == 1 )
        printf( " \n" );
      else
        printf( "訡     䠩 students.db\n" );
    }
    else         // . . updated == 0
    {
      printf( "  , . .    祭 \n" );
    }
    
    break;      // 室  横, . .    ࠡ⠭
  }

  //   ࠢᨫ쭠 ⠪: if ( found == 0 )
  if ( !found )  //  짮⥫ 祢   䠩  
    printf( "  㯯  䠬 㤥\n" );

  // ஥ 䠩
  fclose( students );

  return 0;        // ᯥ譮 襭 楤
}
