/* ****************************************************************************
* Программа: "Привет, мир!" в новом облике
* Автор:     см. prg1.c
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Это заголовочный файл для нашей программы, в нем находятся прототипы
   функций hello() и world(). Прототип функции нужен компилятору для выполнения
   проверки правильности вызова каждой функции в программе. В прототипе
   указываются все формальные параметры, которые принимает функция. Если же
   она не принимает никаких параметров, то вместо них помещается ключевое
   слово void. Слева от имени функции помещается тип значения, возвращаемого
   функцией. Если функция не возвращает никакого значения, то также указывается
   тип void. Прототип функции должен размещаться в тексте программного модуля
   до ее первого вызова, иначе при компиляции произойдет ошибка.
*/

/* обе наши функции не принимают никаких параметров и не возвращают никакого 
   значения
*/ 
void hello( void );
void world( void );

/* Глобальные переменные, которые используются в модулях hello.c и world.c.
   Они ОПРЕДЕЛЕНЫ в модуле hello_world.c, а здесь они ОБЪЯВЛЯЮТСЯ как внешние.
*/
extern char *hello_str;
extern char *world_str;
