/* ****************************************************************************
* :  / 
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//       setlocale()
#include <locale.h>

//    
#include <wchar.h>

#include <stdlib.h>

#define  NAME_LEN  31

/*
         
    ,       UTF-8.
     :
  
  gcc -DWIDE -o prg14 prg14.c

         prg18.c.
*/
#ifdef WIDE
  #define  YES L''
  #define  NO  L''
  #define  FORMAT  "%lc"
#else
  #define  YES ''
  #define  NO  ''
  #define  FORMAT  "%c"
#endif

//    ,     
struct person 
{
  char first_name[ NAME_LEN ];  // 
  char last_name[ NAME_LEN ];   // 
  int height;                   //  ( )
  float weight;                 //  ( )
};

//  C        
//         typedef.
//         , , 
// .
typedef struct person PERSON;


int main( void )
{
  int i, j;        //  

#ifdef WIDE
  wchar_t answer;  //     
#else
  char answer;     //     
#endif

  int count = 0;   //    
  int written;     //    ,    

  //    PERSON
  //  ,        struct
  PERSON student;

  //    FILE (    , . prg6.c)
  FILE *out, *in;

  //       , 
  //    
  if ( !setlocale( LC_CTYPE, "" ) )
  {
    fprintf( stderr, "Can't set locale LC_CTYPE\n" );
    exit( 1 );
  }

  //  :   -  ,  -  
  //  :
  // a -     , . .     
  //     .    ,      
  //     ,       ;
  // b - ,    , . .     
  //             '\n'.
  //             " " 
  //     ( ASCII  13)  " " ( ASCII  10) 
  //       '\n'.        
  //      '\n'   : " "  " 
  //     ".    UNIX   
  //     ,      
  //     . ,   "b"   
  //     fopen()   UNIX  .

  //     "db",   database
  out = fopen( "students.db", "ab" );

  //    ()  ,     NULL
  if ( out == NULL )
  {
    printf( "    students.db\n" );

    //      (    
    //     ,   )
    return 1;
  }

  //    
  printf( "   \n");

  //   C     do...while,   
  //    , . . while...

  //   answer  ,    
  //  
  answer = YES;

  while ( answer == YES )
  {
    //      
    printf( "\n     ,   \n" );
    printf( "(, , , ):\n" );
    scanf( "%s %s %d %f", student.first_name, student.last_name, 
                          &student.height, &student.weight );

    //      students.db
    //   fwrite():
    // - &student -   ,     
    //     ;
    // - sizeof( student ) -     ;
    // - 1 -     (    1, 
    //      , ,      
    //   );
    // - out -  ,    .
    //   -     .
    written = fwrite( &student, sizeof( student ), 1, out );

    if ( written != 1 )
      printf( "      students.db\n" );
    else
      count++;      //  ,    

    //     ,    
    //  scanf()        
    //      
    while ( getchar() != '\n' )
      continue;

    //   ,     , , 
    //   ,       "",
    //       -  ,   ""
    // (     ,   )

    //   answer  ,    
    //  
    answer = '\0';

    while ( answer != YES && answer != NO )
    {
      printf( "\n   (/) ?: " );
      scanf( FORMAT, &answer );

      //     ,    
      //  scanf()        
      //      
      while ( getchar() != '\n' )
        continue;

    }
  }

  //  
  fclose( out );

  //          
  in = fopen( "students.db", "rb" );

  //    
  if ( in == NULL )
  {
    printf( "    students.db\n" );
    return 2;      //     
  }

  printf( "\n\n  students.db\n\n" );

  //      students.db

  i = 1;   //      

  //   fread():
  // - &student -   ,      
  //     ,   ;
  // - sizeof( student ) -     ;
  // - 1 -       (    1,
  //       , ,       
  //     );
  // - in -  ,     .
  //   -     .
  while ( fread( &student, sizeof( student ), 1, in ) == 1 )
  {
    //     
    printf( " %d: %s %s %d %.2f\n", i,
                                           student.first_name,
                                           student.last_name, 
                                           student.height, 
                                           student.weight );
    i++;
  }

  //  
  fclose( in );

  return 0;
}
