/* ****************************************************************************
* : 
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

/*      / */
#include <stdio.h>

/*       strlen() */
#include <string.h>

/*   */ 
void swap( int *first, int *second );
void process_2d_arrays( void );

int main( void )
{
  int abc = 123;

  //     ,    
  //   int;
  //     ,    
  // -   int;  &    
  int *p_abc = &abc;

  //   
  int i;

  //      
  // ( ,        
  // )
  int array[] = { 10, 20, 30, 40, 50 };

  //      int (   ,
  //     "")
  int *p_array;

  //   
  // ( ,        
  // )
  char str[] = "TEST";

  //      swap()
  int first, second;

  printf( "  abc = %d,   p_abc = %p\n",
           abc, p_abc );

  //    abc       
  // 
  printf( "\n,   ,    " \
          "  p_abc: %d\n\n", *p_abc );

  //       sizeof: 
  //          ( )
  //     ( ),     
  // ;
  //  %p  , . . 
  for ( i = 0; i < sizeof( array ) / sizeof( int ); i++ ) 
  {
    printf( "array[ %d ] = %d      = %p\n", i, array[ i ], &array[ i ] );
  }

  printf( "\n      :\n" );

  //        1, . . 
  //   :   ,  
  //   (   - int)    ,
  //      .
  printf( "array[ 2 ] - array[ 1 ] = %p - %p = %d\n\n",
          &array[ 2 ], &array[ 1 ], &array[ 2 ] - &array[ 1 ]
        );

  //        (  
  //    ,   &  )
  p_array = array;

  //         
  // 
  for ( i = 0; i < sizeof( array ) / sizeof( int ); i++ ) 
  {
    //    :    , 
    //    p_array,     2  
    //    ,     p_array
    *p_array = *p_array * 2;

    //        printf()  
    // array[ i ]  *p_array
    printf( "array[ %d ] = %d\n", i, array[ i ] );

    //    1,      
    //   .
    // .        array .
    p_array++;
  }

  printf( "\n" );

  //    ,  
  //  strlen()     ( 
  //  '\0')
  for ( i = 0; i < strlen( str ); i++ ) 
  {
    printf( "%c    ", str[ i ] );
  }

  printf( "\n" );

  printf( "-------------------------------------------\n" );

  //       
  //  .
  printf( "   \n" );
  first = 10;
  second = 20;
  printf( " first = %d,  second = %d\n", first, second );
  swap( &first, &second );
  printf( " first = %d,  second = %d\n", first, second );

  printf( "-------------------------------------------\n" );

  //        .
  process_2d_arrays();

  return 0;
}

/* 
  ,     
*/
void swap( int *first, int *second )
{
  //  --     int

  int temp;           //     
  
  temp = *first;      //    
  *first = *second;   //      
  *second = temp;     //      

  //  *first = *second   :  ,
  //   ,     second, 
  //    ,     first. 
  // *first     (dereferencing 
  // pointer),     .
  
  return;
}

/* 
  ,       
  
*/
void process_2d_arrays( void )
{
  char arr[ 3 ][ 4 ] = { 'a', 'b', 'c', '\0',
                         '1', '2', '3', '\0',
                         '~', '!', '@', '\0' 
                       };
  /*        , 
       */
  /*  char arr[ 3 ][ 4 ] = { 'a', 'b', 'c', 'd',
                         '1', '2', '3', '4',
                         '~', '!', '@', '$' 
                       };*/
  int i, j;
    
  /*       (   '\0') */
  /*      */
  printf( "\n     (  '\\0')\n\n" );
  for ( i = 0; i < 3; i++ )
  {
    /*      */
    for ( j = 0; j < 3; j++ )
    {
      printf( "%c ", arr[ i ][ j ] );

      /*        ,
          .    arr  
          .   ( arr + i )  
            (..      char),
          *( arr + i )    (..   
          char),  *( arr + i ) + j   j-  
          char  i-  ,  *( *( arr + i ) + j )
            j- .
      */

      /*   ,    --
               . */ 
      // printf( "%c ", *( *( arr + i ) + j ) );
    }
    printf( "\n" );
  }    

  /*      ,     
       .    '\0'    
        ,        
      .
  */
  printf( "\n  arr = %s\n\n", arr );      

  /*  ,      . 
       (   )    ,
     ,       ,
               
     , ..          
       .
  */
  printf( "  \n\n" );
  for ( i = 0; i < 3; i++ )
  {
    printf( "  char: arr[ %d ] = %s\n", i, arr[ i ] );
    printf( "  char: *( arr + %d ) = %s\n", i, *( arr + i ) );
    printf( "   char: &arr[ %d ][ 0 ] = %s\n", i, 
                                                             &arr[ i ][ 0 ] );
    printf( "    char: arr + %d = %s\n", i, arr + i );
    printf( "\n" );
  }

  printf( "     \n\n" );
  for ( i = 0; i < 3; i++ )
  {
    printf( " arr + %d = %p\n", i, arr + i );
    printf( " &arr[ %d ] = %p\n", i, &arr[ i ] );
    printf( " *( arr + %d ) = %p\n", i, *( arr + i ) );
    printf( " &arr[ %d ][ 0 ] = %p\n", i, &arr[ i ][ 0 ] );
    printf( "\n" );
  }

  printf( "  arr = %p\n", arr );

  printf( "    arr, &arr[ 0 ]  &arr[ 0 ][ 0 ]\n" );

  return;
}
