/* ****************************************************************************
* :  
* :     
* :     . . 
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//       setlocale()
#include <locale.h>

//       open(), close()  chsize()
#include <fcntl.h>
//#include <io.h>

//        errno
//   
#include <errno.h>

//       malloc()  free()
#include <stdlib.h>

//       GROUP  STUDENT,
//      service()
#include "students.h"


// 
static int service( char *filename );



/* ****************************************************************************
*   
******************************************************************************/
int main( void )
{
  char answer;     //      

  //       , 
  //    
  if ( !setlocale( LC_ALL, "" ) )
  {
    fprintf( stderr, "     LC_CTYPE\n" );
    exit( 1 );
  }

  //   answer  ,    
  //  
  answer = '1';

  while ( answer == '1' || answer == '2' || answer == '3' )
  {
    printf( "1.     \n" );
    printf( "2.     \n" );
    printf( "3.   \n" );
    printf( "4.   \n\n" );

    printf( " : " );
    scanf( "%c", &answer );      //     ,   

    //   
    while ( getchar() != '\n' )
      continue;

    if ( answer == '1' )
    {
      groups();
    }
    else if ( answer == '2' )
    {
      lists();
    }
    else if ( answer == '3' )
    {
      service( "groups.db" );
      service( "students.db" );
    }
    else if ( answer == '4' )
    {
      return 0;
    }
    else    //  -  
    {
      printf( "    \n" );
    }
  }
  return 0;
}


/* ****************************************************************************
*   
*           , 
*   "*" (. .    )
******************************************************************************/
static int service( char *filename )
{
  // :
  // char *filename -   

  //     :   , 
  //  ,   ,  . 
  // ,    ,   ,  
  // .    ""  
  //  .       ,   ,
  //             .

  //    ,    
  int written;

  //     ,     
  //      
  // .   long int -   .
  long int position_read;

  //     ,     
  //         
  long int position_write;

  //  ,    open()   
  int handle;

  //    chsize(),     
  //  (   ,     0)
  int result;

  //      ( )
  int record_len;

  //    ,      
  //   
  char *record;

  //      
  FILE *db;

  //    ,       ,
  //     

  //   ""  groups.db,    
  //    GROUP,    students.h
  if ( strcmp( filename, "groups.db" ) == 0 )
    record_len = sizeof( GROUP );

  //   ""  students.db --  STUDENTS
  else if ( strcmp( filename, "students.db" ) == 0 )
    record_len = sizeof( STUDENT );

  else
  {
    fprintf( stderr, "   : %s\n", filename );
    return 1;   //   ,   
  }  

  //       ,  
  //         (groups.db 
  // students.db)
  record = ( char * )malloc( record_len );

  //        
  db = fopen( filename, "r+b" );

  //    
  if ( db == NULL )
  {
    fprintf( stderr, "    %s\n", filename );
    return 1;   //   ,   
  }

  //    ""  ,   
  //    ,    0
  position_write = 0;

  //     
  //   fread() :
  // -         record
  // ( ,   "&"  );
  // -     1 ;
  // -     record_len;
  // -         - db
  while ( fread( record, 1, record_len, db ) == record_len )
  {
    // ,        
    //  ,      ,  
    //        ,   
    //       ,     . 
    //   ,       
    //  .    ,   
    //       "->". ,
    //    , , ( ( GROUP * )record )->deleted
    if ( ( strcmp( filename, "groups.db" ) == 0 && 
           ( ( GROUP * )record )->deleted 
         ) ||
         ( strcmp( filename, "students.db" ) == 0 && 
           ( ( STUDENT * )record )->deleted 
         )
       )
      //        ,
      //     , . .   
      continue;

    //    --      
    //    
    
    //      ,     
    //  
    position_read = ftell( db );

    //        ,   
    //     ( SEEK_SET ,  
    //     )
    fseek( db, position_write, SEEK_SET );
  
    //     filename
    //   fwrite() :
    // -    ,    
    //   record ( ,   "&"  );
    // -     1 ;
    // -     record_len;
    // -         - db
    written = fwrite( record, 1, record_len, db );

    //  fwrite()      
    if ( written != record_len )
    {
      fprintf( stderr, "      %s\n", filename );
      return 1;
    }

    //      ,     
    //   
    position_write = ftell( db );

    //      ,      
    fseek( db, position_read, SEEK_SET );
  }

  //  
  fclose( db );

  //     ,    "", 
  //        .   
  //     position_write,  
  //         
  //    ,     
  //  .

#ifdef UNIX
  //    UNIX     
  // .         .
  truncate( filename, position_write );
#else
  //    Windows   

  //      
  //   ,        ,
  //         (   -
  // O_RDWR|O_BINARY - ,      
  //       "|", . . "")
  handle = open( filename, O_RDWR|O_BINARY);

  //     position_write
  result = chsize( handle, position_write );

  //  
  close( handle );

  //     chsize()   
  // (  ,      errno)
  if ( result != 0 )   
    printf( " : %d\n", errno );
#endif

  //  
  free( record );

  return 0;
}
