/* ****************************************************************************
* ணࠬ: ᯨ᮪ 㤥⮢
* :     
* :     . . 㭮
* :      10.02.2014
* :    0.2
* ****************************************************************************/

#include <stdio.h>

//   䠩 㦥  㭪樨 setlocale()
#include <locale.h>

//   䠩 㦭  㭪権 open(), close()  chsize()
#include <fcntl.h>
//#include <io.h>

//  ⮬ 筮 䠩 । 쭠 ६ errno
//   祭
#include <errno.h>

//   䠩 㦥  㭪権 malloc()  free()
#include <stdlib.h>

//  ⮬ 筮 䠩 ।  GROUP  STUDENT,
//  ᯮ  襩 㭪樨 service()
#include "students.h"


// ⨯
static int service( char *filename );



/* ****************************************************************************
*  㭪 ணࠬ
******************************************************************************/
int main( void )
{
  char answer;     // ⢥ 짮⥫  롮 㭪 

  // ⠭  襩 ணࠬ  ࠬ 樨, 
  // ⠭  樮 ⥬
  if ( !setlocale( LC_ALL, "" ) )
  {
    fprintf( stderr, "  ⠭ ࠬ 樨 LC_CTYPE\n" );
    exit( 1 );
  }

  // ᢮ ६ answer ⠪ 祭, ஥   
  //  横
  answer = '1';

  while ( answer == '1' || answer == '2' || answer == '3' )
  {
    printf( "1.   ᠭﬨ 㤥᪨ 㯯\n" );
    printf( "2.   ᯨ᪠ 㤥᪨ 㯯\n" );
    printf( "3. 㦨  \n" );
    printf( "4. 室  ணࠬ\n\n" );

    printf( "롥 ⢨: " );
    scanf( "%c", &answer );      // ⢥ 稬   ᨬ,   ᫠

    // ⨬  
    while ( getchar() != '\n' )
      continue;

    if ( answer == '1' )
    {
      groups();
    }
    else if ( answer == '2' )
    {
      lists();
    }
    else if ( answer == '3' )
    {
      service( "groups.db" );
      service( "students.db" );
    }
    else if ( answer == '4' )
    {
      return 0;
    }
    else    // ࠭ - 㣮 ᨬ
    {
      printf( " ࠢ  㭪 \n" );
    }
  }
  return 0;
}


/* ****************************************************************************
* 㦨  
*  㭪 㤠  䠩 襩 ⮩    , 
*   "*" (. . ।祭  䨧᪮ 㤠)
******************************************************************************/
static int service( char *filename )
{
  // ࠬ:
  // char *filename -  䠩 

  //  ⬠ ⮩ 㭪樨 ⠪: ᬠਢ  䠩, 
  //  ﬨ, 祭묨  㤠,  ᢮. 
  // ,  祭  㤠,  砫 䠩, ᯮ ᢮
  // . ᫥ 襭 楤 "ࠣ樨" 䠩 믮
  //  祭. ᫨  䠩    , 祭  㤠,
  //    㤥 ⠭    ᠭ  ᢮  .

  // 稪 ᫠  , ᯥ譮 ᠭ  䠩
  int written;

  //  㪠⥫  䠩 , 稭  ன 㤥 த
  // ⥭ 䠩  ᫥饩 樨 横
  // .   long int -   楫.
  long int position_read;

  //  㪠⥫  䠩 , 稭  ன 㤥 த
  //     䠩  ᫥饩 樨 横
  long int position_write;

  // ਯ 䠩,  頥 㭪 open()   ⨨
  int handle;

  // १ ࠡ 㭪樨 chsize(),  㪮稢 䠩  㦭
  //  (᫨ 㭪 訫 ᯥ譮,   頥 祭 0)
  int result;

  //    䠩  (᫮ ⮢)
  int record_len;

  // 㪠⥫   ,   㤥 뢠  
  //  䠩 
  char *record;

  // ⮪  ࠡ  䠩 
  FILE *db;

  //  祭  ,   㤥 뢠   䠩,
  // 㦭   ⮩ 

  // ᫨ 㭪 "ࠣ" 䠩 groups.db,    㤥
  // ࠢ ࠧ  GROUP, ।  䠩 students.h
  if ( strcmp( filename, "groups.db" ) == 0 )
    record_len = sizeof( GROUP );

  // ᫨ 㭪 "ࠣ" 䠩 students.db --  STUDENTS
  else if ( strcmp( filename, "students.db" ) == 0 )
    record_len = sizeof( STUDENT );

  else
  {
    fprintf( stderr, "୮  䠩 : %s\n", filename );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }  

  // ᨬ  樮 ⥬ ⮫쪮 ⮢ , ᪮쪮 室
  //  ࠧ饭    ⭮ 䠩  (groups.db 
  // students.db)
  record = ( char * )malloc( record_len );

  // ஥ 䠩  ० ⥭   
  db = fopen( filename, "r+b" );

  // ஢塞 ᯥ譮  䠩
  if ( db == NULL )
  {
    fprintf( stderr, "   䠩 %s\n", filename );
    return 1;   // ⨬ 㫥 祭, 饥 稥 訡
  }

  //  砫  "ࠣ樨" 䠩 ,  ன 㤥
  // த   䠩, 筮  ࠢ 0
  position_write = 0;

  // ⠥ 䠩   
  // ࠬ 㭪樨 fread() ᫥騥:
  // - ⠭  ࠧ     ᮬ record
  // ( ,   "&"  㦥);
  // - ࠧ   ⠢ 1 ;
  // - ᫮ ⠪  ࠢ record_len;
  // - 㪠⥫   ⮪  ࠡ  䠩 - db
  while ( fread( record, 1, record_len, db ) == record_len )
  {
    // ஢ਬ,  祭  ᫨    㤠
    //  ⮣, ⮡  祭 ਧ 㤠 , 뫮 
    // 㤮       ,   ⠫
    //   䠩   ᨢ ᨬ,     . 室
    // ⮨  ⮬, ⮡ ८ࠧ  ᨢ ᨬ  㪠⥫
    //  . ᪮  稫 㪠⥫,   饭
    //  ⠬  㦭 ᯮ짮  "->". 筮,
    // 諮 ᯮ짮  ᪮, ਬ, ( ( GROUP * )record )->deleted
    if ( ( strcmp( filename, "groups.db" ) == 0 && 
           ( ( GROUP * )record )->deleted 
         ) ||
         ( strcmp( filename, "students.db" ) == 0 && 
           ( ( STUDENT * )record )->deleted 
         )
       )
      // ᪮ ⮫쪮  ⠭  祭  㤠,
      //  室  砫 横, . . ⠥ ᫥ 
      continue;

    // 諨 㤠  -- 㦭 ६    砫
    // 䠩  ᢮ 
    
    //  ⥪  㪠⥫  䠩,  ⮩ 樨  த
    //  䠩
    position_read = ftell( db );

    // ६⨬ 㪠⥫ 樨  䠩  ⮬ ,  ண 
    // த   䠩 (ࠬ SEEK_SET 砥,  
    // 樨 믮   䠩)
    fseek( db, position_write, SEEK_SET );
  
    // 襬   䠩 filename
    // ࠬ 㭪樨 fwrite() ᫥騥:
    // -  䠩 뢠 , ࠧ饭   
    //  ᮬ record ( ,   "&"  㦥);
    // - ࠧ   ⠢ 1 ;
    // - ᫮ ⠪  ࠢ record_len;
    // - 㪠⥫   ⮪  ࠡ  䠩 - db
    written = fwrite( record, 1, record_len, db );

    // 㭪 fwrite() 頥 ᫮ ᯥ譮 ᠭ  
    if ( written != record_len )
    {
      fprintf( stderr, "訡     䠩 %s\n", filename );
      return 1;
    }

    //  ⥪  㪠⥫  䠩,  ⮩ 樨  த
    //   䠩
    position_write = ftell( db );

    // ୥  ⮩ 樨  䠩,  ன 㦭 த ⥭ 
    fseek( db, position_read, SEEK_SET );
  }

  // ஥ 䠩
  fclose( db );

  //    㪮 䠩, १   "墮", 
  //  ண 㦥 ७ᥭ   砫 䠩.   䠩
  // । ᮣ᭮ 祭 ६ position_write, ⮬ 
  // ᫥ 襭 ࠡ⪨ ᥣ 䠩  ६ 㪠뢠 
  //    䠩,  ᯮ   ᫥
  // ६饭 .

#ifdef UNIX
  //  樮 ⥬ UNIX  ᯮ짮 ᫥騩 맮 㭪樨
  // .    ᤥ ஢ ᯥ譮 ࠡ ⮩ 㭪樨.
  truncate( filename, position_write );
#else
  //  樮 ⥬ Windows 㯠 ᫥騬 ࠧ

  // ஥ 䠩   ⮩ 㭪樨
  // ன ࠬ 砥,  䠩 뢠  ० ⥭  ,
  //  ⠪   ᬠਢ   䠩 (⠪ ଠ ࠬ -
  // O_RDWR|O_BINARY - 砥,   祭 ନ  
  // ⮢   ⮢ ᪮ 樨 "|", . . "")
  handle = open( filename, O_RDWR|O_BINARY);

  // 㪮⨬ 䠩   position_write
  result = chsize( handle, position_write );

  // ஥ 䠩
  close( handle );

  //  砥 訡 㭪 chsize()  㫥 祭
  // (뢥  訡,  뢠   ६ errno)
  if ( result != 0 )   
    printf( " 訡: %d\n", errno );
#endif

  // ᢮ 
  free( record );

  return 0;
}
