/* ****************************************************************************
* Программа: "Привет, мир!" в новом облике
* Автор:     см. prg1.c
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Это заголовочный файл для нашей программы, в нем находятся прототипы
   функций hello() и world(). 
   Обратите внимание, что имя заголовочного файла помещено не в угловых
   скобках <>, а в двойных кавычках. Это означает, что данный файл находится
   не в системном каталоге, о котором "знает" компилятор, а в каталоге,
   который определил программист. В нашем случае этот файл располагается
   в текущем каталоге, в котором находятся и файлы с расширением .c.
*/
#include "hello_world.h"

/* На примере этой простой, но вместе с тем, очень знаменитой, программы
   проиллюстрируем три понятия: 1) функция; 2) многомодульная программа;
   3) глобальные переменные.
   Программа состоит из трех модулей, т. е. программных файлов. 
*/

/* Это глобальные переменные. Они будут доступны и в модулях hello.c
   и world.c, поскольку они объявлены как extern в заголовочном файле 
   hello_world.h.
*/
char *hello_str = "Привет";
char *world_str = "мир";


int main( void )
{
  hello();    // эта функция выводит слово "Привет"
  world();    // эта функция выводит слово "мир"

  return 0;
}
