/* ****************************************************************************
* Программа: первая программа на языке C (легендарный "Привет, мир!")
* Автор:     показал ее (или напомнил о ней?) студентам Е. П. Моргунов.
*            Кто является автором, не помню. Эта программа, как "Черный 
*            квадрат" К. Малевича -- ЛЮБОЙ может ее повторить, но написать
*            ее ВПЕРВЫЕ в мире уже невозможно!
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Это так называемый ВКЛЮЧАЕМЫЙ файл, или заголовочный файл. В таких файлах
   содержатся сведения, используемые компилятором при создании объектного
   файла, т. е. модуля, представленного в машинных кодах.
*/
#include <stdio.h>

/* int - это тип данных, означающий ЦЕЛОЕ ЧИСЛО. Функция возвращает значение
   целого типа операционной системе. Слово void означает, что функция main()
   не принимает никаких параметров. Функция main() - это главная функция
   в программе на языке C. Выполнение программы всегда начинается именно
   с этой функции. Фигурные скобки ограничивают тело функции, они могут
   также ограничивать блок операторов внутри функции.
*/
int main( void )
{
  /* Эта функция называется библиотечной. Для ее использования в программе
     должен быть включен заголовочный файл stdio.h (что мы и сделали вверху).
     Эта функция выводит текст, заключенный в двойные кавычки, на экран.
     Символы '\n' в конце строки означают перевод строки. При этом в системе
     Windows это символы CR/LF, имеющие ASCII-коды 13 (carriage return) и
     10 (line feed), а в системе UNIX (Linux, FreeBSD и др.) -- только один
     символ LF (line feed). Обратите внимание, что в конце оператора ставится
     символ ";".
  */
  printf( "Привет, мир!\n" );

  /* Это ключевое слово языка C означает завершение работы данной функции.
     Управление передается той функции, из которой была вызвана данная
     функция. При выполнении данного оператора в функции main() управление
     передается операционной системе, т. е. работа программы завершается,
     а операционная система получает так называемый код возврата, равный 0,
     что означает успешное завершение программы. 
  */
  return 0;
}
