/* ****************************************************************************
* Программа: основы ввода/вывода
* Автор:     Е. П. Моргунов
* Дата:      10.02.2014
* Версия:    0.2
* ****************************************************************************/

/* Это заголовочный файл. Обратите внимание на угловые скобки <> */
#include <stdio.h>


int main( void )
{
  /* объявим переменные следующих типов:
     char  - это тип данных для хранения одного символа;
     int   - это тип данных для хранения целого числа;
     float - это тип данных для хранения числа с плавающей запятой;
     char name[ 80 ] - массив для хранения 80 символов.
  */
  char  letter;         // одна буква алфавита
  int   age;            // возраст
  float average_mark;   // средний балл по итогам экзаменационной сессии
  char  name[ 80 ];     // имя

  /* Организуем ввод данных с клавиатуры. Функция scanf() является
     библиотечной. Для ее использования в программе должен быть включен
     заголовочный файл stdio.h (что мы и сделали вверху).

     Обратите внимание на символ & перед именами переменных в вызове функции
     scanf(). Этот символ означает адрес переменной (ячейки памяти). Однако
     перед именем массива символ & ставить не нужно, т. к. имя массива уже
     является адресом его первого элемента. Символы %c, %d, %f, %s в строке
     формата функции scanf() указывают на соответствующие типы данных.
  */
  printf( "Введите какую-нибудь букву: " );
  scanf( "%c", &letter );

  printf( "Введите ваш возраст (целое число лет): " );
  scanf( "%d", &age );

  // символ "\" в конце строки позволяет "склеить" две строковые константы 
  printf( "Введите ваш средний балл за последнюю сессию " \
          "(с точностью до 2 знаков после запятой): " );
  scanf( "%f", &average_mark );

  printf( "Введите ваше имя: " );
  scanf( "%s", name );

  /* а теперь организуем вывод данных на дисплей */
  printf( "Вы ввели букву %c\n", letter );
  printf( "Ваш возраст %d\n", age );


  /* спецификация %.2f означает, что число будет выведено с двумя знаками
     после запятой */
  printf( "Ваш средний балл %.2f\n", average_mark );
  printf( "Ваше имя %s\n", name );
                                          
  return 0;
}
